O - Soldier and Badges

Colonel has n badges. He wants to give one badge to every of his n soldiers. Each badge has a coolness factor, which shows how much it‘s owner reached. Coolness factor can be increased by one for the cost of one coin.

For every pair of soldiers one of them should get a badge with strictly higher factor than the second one. Exact values of their factors aren‘t important, they just need to have distinct factors.

Colonel knows, which soldier is supposed to get which badge initially, but there is a problem. Some of badges may have the same factor of coolness. Help him and calculate how much money has to be paid for making all badges have different factors of coolness.

Input

First line of input consists of one integer n (1?≤?n?≤?3000).

Next line consists of n integers ai (1?≤?ai?≤?n), which stand for coolness factor of each badge.

Output

Output single integer — minimum amount of coins the colonel has to pay.

Example

Input

41 3 1 4

Output

1

Input

51 2 3 2 5

Output

2

Note

In first sample test we can increase factor of first badge by 1.

In second sample test we can increase factors of the second and the third badge by1.

第一种方法:

是从网上看到的,感觉和我的思路一样但是可以通过

 1 #include<iostream>
 2 #include<algorithm>
 3 using namespace std;
 4 const int  MAX = 3000 + 5;
 5 int a[MAX];
 6 int Mi;
 7 int N;
 8
 9 int main()
10 {
11     int temp = -1;
12     Mi = 0;
13     cin>>N;
14
15     for(int i = 0;i < N;i++)
16         cin>>a[i];
17     sort(a,a+N);
18
19     for(int i = 0;i < N;i++)
20     {
21         if(a[i] > temp)
22             temp = a[i];
23         else
24             Mi += ++temp - a[i];
25     }
26     cout<<Mi<<endl;
27
28
29     return 0;
30 }

第二种方法:

完全自己的思路,但是不能通过,不知道哪错了

 1 #include<cstdio>
 2 #include<cstring>
 3 #include<algorithm>
 4 #include<set>
 5 #include<iostream>
 6 #include<algorithm>
 7
 8 using namespace std;
 9
10 const int  MAX = 3000 + 5;
11 int a[MAX];
12 int Mi;
13 int N;
14
15 void DP ( int t )
16 {
17     while( a[t] != -1)
18     {
19         Mi++;
20         t++;
21         if(t > N ){ cout<<" XXXX "<<endl;break;}
22     }
23     a[t] = t;
24 }
25
26 int main()
27 {
28     Mi = 0;
29
30     int temp;
31     cin>>N;
32
33     memset(a,-1,sizeof(a));
34
35     for(int i = 1;i <= N;i++)
36         {
37             cin>>temp;
38             if( a[temp] == -1 )
39                 a[temp] = temp;
40             else
41                 DP( temp );
42         }
43     cout<<Mi<<endl;
44
45
46     return 0;
47 }
时间: 2024-10-15 17:55:26

O - Soldier and Badges的相关文章

Week 1 # O Soldier and Badges

原题描述: O - Soldier and Badges Colonel has n badges. He wants to give one badge to every of his n soldiers. Each badge has a coolness factor, which shows how much it's owner reached. Coolness factor can be increased by one for the cost of one coin. For

贪心 Codeforces Round #304 (Div. 2) B. Soldier and Badges

题目传送门 1 /* 2 题意:问最少增加多少值使变成递增序列 3 贪心:排序后,每一个值改为前一个值+1,有可能a[i-1] = a[i] + 1,所以要 >= 4 */ 5 #include <cstdio> 6 #include <cstring> 7 #include <algorithm> 8 using namespace std; 9 10 typedef long long ll; 11 12 const int MAXN = 3e3 + 10;

Codeforces Round #304 (Div. 2)——1002—— Soldier and Badges

Colonel has n badges. He wants to give one badge to every of his n soldiers. Each badge has a coolness factor, which shows how much it's owner reached. Coolness factor can be increased by one for the cost of one coin. For every pair of soldiers one o

Soldier and Badges (set的检索简单运用)

Colonel has n badges. He wants to give one badge to every of his n soldiers. Each badge has a coolness factor, which shows how much it's owner reached. Coolness factor can be increased by one for the cost of one coin. For every pair of soldiers one o

CF 546B Soldier and Badges

Describe Colonel has n badges. He wants to give one badge to every of his n soldiers. Each badge has a coolness factor, which shows how much it's owner reached. Coolness factor can be increased by one for the cost of one coin. For every pair of soldi

Soldier and Badges

题目链接:http://acm.hust.edu.cn/vjudge/problem/visitOriginUrl.action?id=173144 题意: 输入n个数,要使这n个数都不相同,且只能加,输出最少要加的多少. 案例: 1)input 4 1 3 1 4 output 1 2)input 5 1 2 3 2 5 output 2 思路分析: 利用插空法.尽量减少循环. 先对数组进行排序,再找出有x个相同的数,且把相同的数存在另一个数组c中.因为这个数组c也是排序的,所以只要找出x个比

546B. Soldier and Badges

题目链接 题意: n个数,要保证这n个数完全不相同,求需要把原来的数增加多少,求这个值得最小值   Java 程序 import java.io.PrintStream; import java.util.Arrays; import java.util.Scanner; import java.util.Set; import java.util.TreeSet; public class B546 { static void run(){ Scanner in = new Scanner(S

codeforce 304 B. Soldier and Badges

<span style="font-family: 'Courier New'; background-color: rgb(255, 255, 255);"> </span><span style="font-family: 'Courier New'; background-color: rgb(255, 255, 255);">第一次打cf,感觉挺爽的,页面看着很爽,大概是因为这次的比较简单吧,这道题有点像FZU的最小花费,

Codeforces546B:Soldier and Badges

题意: 给出一些数字,要求每个数字都不一样需要增加几 思路: 先排序,然后一个个增加,最后求总和差 #include <iostream> #include <stdio.h> #include <string.h> #include <string> #include <stack> #include <queue> #include <map> #include <set> #include <vec